#include <cstdio>

#include <argh.hh>

using namespace std;

int main(int argc, const char *const *argv)
{
    ParamHandler Argh;
    
    Argh.AddLong("help",    'h').SetBool().SetDesc("This help.");
    Argh.AddLong("version", 'V').SetBool().SetDesc("Displays version information.");

    Argh.StartParse(argc, argv);
    for(;;)
    {
        int c = Argh.GetParam();
        if(c == -1)break;
        switch(c)
        {
            case 'V': printf("%s\n", VERSION); return 0;
            case 'h':
                printf(
                    "This is software\n"
                    "\nUsage: software [<option> [<...>]] <file> [<...>]\n"
                    "\nThis software does something for the files.\n"
                    "\nOptions:\n");
                Argh.ListOptions();
                printf("\nNo warranty whatsoever.\n");
                return 0;
            default:
                fprintf(stderr, "Not implemented\n");
        }
    }
    if(!Argh.ok())return -1;
    
    fprintf(stderr, "Not implemented\n");
    return 0;
}
